template <class Elem> 
class CodaBase {
 public:
        virtual bool enqueue(Elem) = 0;
        virtual bool dequeue() = 0;
        virtual bool head(Elem &e) = 0;
        virtual bool isempty() = 0;
};

template <class Elem> 
class Coda : public CodaBase {
 private:
        Elem  *dati;
        int   MaxSize;
        int   CurSize;       // # elem in coda
 public:

        Coda(int ms)
        {
              MaxSize = ms;
              CurSize = 0;
              dati = new Elem[MaxSize];      
        }

        ~Coda()
        {
               delete[] dati;       
        }

        bool enqueue(Elem e)
        {
             if (CurSize==MaxSize)
             {
                return false;                     
             }    
             
             dati[CurSize] = e;
             CurSize++;
             return true;
        };

        bool dequeue() {
             
             if (CurSize==0) return false;
             
             for(int i=0; i<CurSize-1; i++)
                    dati[i] = dati[i+1];
             CurSize = CurSize -1;
             // CurSize--;    
             return true;
        };

        bool head(Elem &e)
        {
             if (CurSize>0)
                return dati[0]; 
             else {
                  cerr << "Errore" << endl;
                  exit(-1);
             }
        };

        bool isempty() {if (CurSize==0) return true; else return false;};      

}
